Index: /XIOS/trunk/src/filter/pass_through_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/pass_through_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/pass_through_filter.cpp	(revision 1704)
@@ -1,3 +1,6 @@
 #include "pass_through_filter.hpp"
+#include "workflow_graph.hpp"
+#include "field.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -5,8 +8,45 @@
   CPassThroughFilter::CPassThroughFilter(CGarbageCollector& gc)
     : CFilter(gc, 1, this)
-  { /* Nothing to do */ }
+  { 
+  }
+
+  void CPassThroughFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = this->tag ? data[0]->timestamp >= this->field->field_graph_start && data[0]->timestamp <= this->field->field_graph_end : false;
+
+    if(building_graph)
+    {
+      // std::cout<<"CPassThroughFilter::apply field_id = "<<this->field->getId()<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
+      this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;
+
+      CWorkflowGraph::allocNodeEdge();
+
+      CWorkflowGraph::addNode(this->filterID, "Pass Through Filter\\n("+data[0]->field->getId()+")", 2, 1, 1, data[0]);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+      if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+
+      
+      if(CWorkflowGraph::build_begin)
+      {
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0;
+      }
+      else CWorkflowGraph::build_begin = true;
+      
+      data[0]->src_filterID=this->filterID;
+      data[0]->distance++;
+
+    }
+
+    data[0]->field = this->field;
+  }
 
   CDataPacketPtr CPassThroughFilter::apply(std::vector<CDataPacketPtr> data)
   {
+    if(CXios::isClient) buildGraph(data);
     return data[0];
   }
Index: /XIOS/trunk/src/filter/pass_through_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/pass_through_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/pass_through_filter.hpp	(revision 1704)
@@ -20,4 +20,6 @@
       CPassThroughFilter(CGarbageCollector& gc);
 
+      inline StdString GetName(void) {return StdString("Pass through filter");};
+
     protected:
       /*!
@@ -28,4 +30,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      void virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CPassThroughFilter
 } // namespace xios
Index: /XIOS/trunk/src/filter/source_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/source_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/source_filter.cpp	(revision 1704)
@@ -4,4 +4,5 @@
 #include "calendar_util.hpp"
 #include <limits> 
+#include "workflow_graph.hpp"
 
 namespace xios
@@ -23,4 +24,28 @@
             "Impossible to construct a source filter without providing a grid.");
   }
+
+  void CSourceFilter::buildGraph(CDataPacketPtr packet)
+  {
+    bool building_graph = this->tag ? packet->timestamp >= this->field->field_graph_start && packet->timestamp <= this->field->field_graph_end : false;
+    if(building_graph)
+    {
+      this->filterID = InvalidableObject::filterIdGenerator++;  
+      packet->src_filterID=this->filterID;
+      packet->field = this->field;
+      packet->distance = 1;
+      
+    
+      CWorkflowGraph::allocNodeEdge();
+
+      CWorkflowGraph::addNode(this->filterID, "Source Filter ", 1, 1, 0, packet);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].field_id = this->field->getId();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = 1;
+
+      CWorkflowGraph::build_begin = true;
+    }
+
+  }
+
 
   template <int N>
@@ -59,4 +84,8 @@
       }
     }
+
+    if(CXios::isClient) buildGraph(packet);
+    
+
 
     onOutputReady(packet);
Index: /XIOS/trunk/src/filter/source_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/source_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/source_filter.hpp	(revision 1704)
@@ -35,4 +35,6 @@
                     double defaultValue = 0.0);
 
+      inline StdString GetName(void) {return StdString("Source filter");};
+
       /*!
        * Transforms the data received from the model into a packet and send it
@@ -45,4 +47,6 @@
       template <int N>
       void streamData(CDate date, const CArray<double, N>& data);
+
+      void virtual buildGraph(CDataPacketPtr packet);
 
       /*!
@@ -62,4 +66,5 @@
        */
       void signalEndOfStream(CDate date);
+      int filterID;
 
     private:
Index: /XIOS/trunk/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.cpp	(revision 1704)
@@ -4,4 +4,6 @@
 #include "context_client.hpp"
 #include "timer.hpp"
+#include "workflow_graph.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -64,5 +66,5 @@
   {
     CSpatialTransformFilterEngine* spaceFilter = static_cast<CSpatialTransformFilterEngine*>(engine);
-    CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue);
+    CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue, this->tag, this->start_graph, this->end_graph, this->field);
     if (outputPacket)
       onOutputReady(outputPacket);
@@ -96,5 +98,5 @@
   {
     CSpatialTransformFilterEngine* spaceFilter = static_cast<CSpatialTransformFilterEngine*>(engine);
-    CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue);
+    CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue, this->tag, this->start_graph, this->end_graph, this->field);
 
     if (outputPacket)
@@ -121,4 +123,5 @@
         packet->data.resize(tmpData.numElements());
         packet->data = tmpData;
+        packet->field = this->field;
         onOutputReady(packet);
         tmpData.resize(0) ;
@@ -159,6 +162,37 @@
   }
 
-  CDataPacketPtr CSpatialTransformFilterEngine::applyFilter(std::vector<CDataPacketPtr> data, double defaultValue)
-  {
+  bool CSpatialTransformFilterEngine::buildGraph(std::vector<CDataPacketPtr> data, int tag, Time start_graph, Time end_graph, CField *field)
+  {
+    bool building_graph = tag ? data[0]->timestamp >= start_graph && data[0]->timestamp <= end_graph : false;
+    if(building_graph)
+    {
+      this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;    
+
+      CWorkflowGraph::allocNodeEdge();
+
+      CWorkflowGraph::addNode(this->filterID, "Spatial Transform Filter", 4, 1, 1, data[0]);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = field->record4graphXiosAttributes();
+      if(field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +field->file->record4graphXiosAttributes();
+
+
+      if(CWorkflowGraph::build_begin)
+      {
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0;
+      }
+      else CWorkflowGraph::build_begin = true;
+    }
+
+    return building_graph;
+  }
+
+  CDataPacketPtr CSpatialTransformFilterEngine::applyFilter(std::vector<CDataPacketPtr> data, double defaultValue, int tag, Time start_graph, Time end_graph, CField *field)
+  {
+    
+    bool BG = buildGraph(data, tag, start_graph, end_graph, field);
+
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -177,11 +211,16 @@
       if (0 != packet->data.numElements())
         (packet->data)(0) = defaultValue;
-      apply(data[0]->data, packet->data);
-    }
+      if(BG) apply(data[0]->data, packet->data, this->filterID);
+      else apply(data[0]->data, packet->data);
+    }
+
+    if(BG) packet->src_filterID=this->filterID;
+    if(BG) packet->distance=data[0]->distance+1;
+    packet->field = field;
 
     return packet;
   }
 
-  void CSpatialTransformFilterEngine::apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest)
+  void CSpatialTransformFilterEngine::apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest, int filterID)
   {
     CTimer::get("CSpatialTransformFilterEngine::apply").resume(); 
@@ -296,4 +335,9 @@
         const std::vector<std::pair<int,double> >& localIndex_p = itRecv->second;
         int srcRank = itRecv->first;
+
+        if(filterID >=0) // building_graph
+        {
+           (*CWorkflowGraph::mapFilters_ptr_with_info)[filterID].filter_name = (*itAlgo)->getName();
+        } 
         if (srcRank != rank)
         {
Index: /XIOS/trunk/src/filter/spatial_transform_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/spatial_transform_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/spatial_transform_filter.hpp	(revision 1704)
@@ -3,4 +3,5 @@
 
 #include "filter.hpp"
+#include "field.hpp"
 
 namespace xios
@@ -9,4 +10,6 @@
   class CGridTransformation;
   class CSpatialTransformFilterEngine;
+
+  class CField;
 
   /*!
@@ -24,5 +27,8 @@
        * \param [in] inputSlotsCount number of input, by default there is only one for field src
        */
-      CSpatialTransformFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, double outputValue, size_t inputSlotsCount = 1);
+      CSpatialTransformFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine,
+                              double outputValue, size_t inputSlotsCount = 1);
+
+      inline StdString GetName(void) {return StdString("Spatial transform filter");};
 
       /*!
@@ -93,4 +99,8 @@
   {
     public:
+
+      int filterID;
+      int tag;
+      CField *field;
       /*!
        * Returns the engine wrapping the specified grid transformation.
@@ -109,5 +119,6 @@
        * \return the result of the grid transformation
        */
-      CDataPacketPtr applyFilter(std::vector<CDataPacketPtr> data, double defaultValue = 0);
+      CDataPacketPtr applyFilter(std::vector<CDataPacketPtr> data, double defaultValue = 0, int tag=0, Time start_graph=0, Time end_graph=-1, CField *field=0);
+      bool buildGraph(std::vector<CDataPacketPtr> data, int tag=0, Time start_graph=0, Time end_graph=-1, CField *field=0);
 
        /*!
@@ -136,5 +147,5 @@
        * \param dataDest the resulting transformed data
        */
-      void apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest);
+      void apply(const CArray<double, 1>& dataSrc, CArray<double,1>& dataDest, int filterID=-1);
 
       CGridTransformation* gridTransformation; //!< The grid transformation used by the engine
Index: /XIOS/trunk/src/filter/store_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/store_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/store_filter.cpp	(revision 1704)
@@ -3,4 +3,5 @@
 #include "grid.hpp"
 #include "timer.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -76,6 +77,34 @@
   template CDataPacket::StatusCode CStoreFilter::getData<7>(Time timestamp, CArray<double, 7>& data);
 
+  void CStoreFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+
+    if(building_graph)
+    {
+      this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;
+
+      CWorkflowGraph::allocNodeEdge();
+ 
+      CWorkflowGraph::addNode(this->filterID, "Store Filter", 7, 0, 1, data[0]);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = ++(data[0]->distance);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+      if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+
+      // if(CXios::isClient) std::cout<<"CStoreFilter::apply filter tag = "<<this->tag<<std::endl;
+
+      if(CXios::isClient && CWorkflowGraph::build_begin) 
+      {
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0;
+      }
+      else CWorkflowGraph::build_begin = true;
+    }
+  }
+
   void CStoreFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
+    buildGraph(data);
 
     CDataPacketPtr packet;
Index: /XIOS/trunk/src/filter/store_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/store_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/store_filter.hpp	(revision 1704)
@@ -3,4 +3,6 @@
 
 #include "input_pin.hpp"
+#include "workflow_graph.hpp"
+
 
 namespace xios
@@ -8,4 +10,5 @@
   class CContext;
   class CGrid;
+  class CField;
 
   /*!
@@ -73,4 +76,12 @@
       void virtual invalidate(Time timestamp);
 
+      int filterID;
+      int tag;
+      Time start_graph;
+      Time end_graph;
+      CField *field;
+      int distance;
+
+
     protected:
       /*!
@@ -80,4 +91,5 @@
        */
       void virtual onInputReady(std::vector<CDataPacketPtr> data);
+      void virtual buildGraph(std::vector<CDataPacketPtr> data);
 
     private:
Index: /XIOS/trunk/src/filter/temporal_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/temporal_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/temporal_filter.cpp	(revision 1704)
@@ -2,4 +2,6 @@
 #include "functor_type.hpp"
 #include "calendar_util.hpp"
+#include "workflow_graph.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -22,5 +24,4 @@
                         this->samplingOffset.second, this->samplingOffset.timestep)
     , initDate(initDate)
-//    , nextSamplingDate(initDate + (this->samplingOffset + initDate.getRelCalendar().getTimeStep()))
     , nextSamplingDate(initDate + offsetMonth + ( offsetAllButMonth + initDate.getRelCalendar().getTimeStep()))
     , nbOperationDates(1)
@@ -28,9 +29,60 @@
 //    , nextOperationDate(initDate + opFreq + this->samplingOffset)
     , isFirstOperation(true)
+    , temp_op(opId)
   {
   }
 
+  
+
+
+
+  bool CTemporalFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph=this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+   
+    if(building_graph)
+    {
+      if(this->filterIDoutputs.size()==0) this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;
+      
+      // std::cout<<"CTemporalFilter::apply filter tag = "<<this->tag<<" start = "<<this->start_graph<<" end = "<<this->end_graph<<std::endl;
+
+      CWorkflowGraph::allocNodeEdge();
+
+      if(this->filterIDoutputs.size()==0)
+      {
+        CWorkflowGraph::addNode(this->filterID, "Temporal Filter\\n("+this->temp_op+")", 5, 1, 0, data[0]);   
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].transform_type = this->temp_op;   
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].inputs_complete = false ;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].clusterID = 1 ;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = (data[0]->distance);
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      }
+
+      if(CWorkflowGraph::build_begin)
+      {
+
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb += 1 ;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = max(data[0]->distance+1, (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance);
+      }
+
+
+      this->filterIDoutputs.push_back(data[0]->src_filterID); 
+    }
+
+    return building_graph;
+  }
+
+
   CDataPacketPtr CTemporalFilter::apply(std::vector<CDataPacketPtr> data)
   {
+    bool BG = buildGraph(data);
+
     CDataPacketPtr packet;
 
@@ -43,5 +95,4 @@
       {
         usePacket = (data[0]->date >= nextSamplingDate);
-//        outputResult = (data[0]->date + samplingFreq > nextOperationDate);
         outputResult = (data[0]->date  > initDate + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth);
         copyLess = (isInstantOperation && usePacket && outputResult);
@@ -80,5 +131,15 @@
 
         isFirstOperation = false;
-//        nextOperationDate = initDate + samplingFreq + nbOperationDates*opFreq - samplingFreq + offsetMonth + offsetAllButMonth;
+        
+        packet->field = this->field;
+        
+        if(BG)
+        {
+          packet->src_filterID=this->filterID;
+          packet->distance = data[0]->distance+1;
+          this->filterIDoutputs.clear();
+          CWorkflowGraph::build_begin=true;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].inputs_complete = true ;
+        }
       }
     }
Index: /XIOS/trunk/src/filter/temporal_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/temporal_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/temporal_filter.hpp	(revision 1704)
@@ -31,4 +31,6 @@
                       bool ignoreMissingValue = false);
 
+      inline StdString GetName(void) {return StdString("Temporal filter");};
+
       /*!
        * Applies the temporal operation to the input data and returns the result when it is ready.
@@ -38,4 +40,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      bool virtual buildGraph(std::vector<CDataPacketPtr> data);
 
       /*!
@@ -52,4 +55,8 @@
        */
       bool virtual isDataExpected(const CDate& date) const;
+      std::vector<int > filterIDoutputs;
+      std::vector<std::pair<int, int> > filterIDoutputs_pair;
+
+      StdString temp_op;
 
     private:
